Index: /pjproject/trunk/pjmedia/src/pjmedia-audiodev/wmme_dev.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-audiodev/wmme_dev.c	(revision 5034)
+++ /pjproject/trunk/pjmedia/src/pjmedia-audiodev/wmme_dev.c	(revision 5035)
@@ -895,4 +895,7 @@
     enum { MAX_BURST = 1000 };
 
+    /* Suppress compile warning for unused debugging vars */
+    PJ_UNUSED_ARG(rec_cnt);
+    PJ_UNUSED_ARG(play_cnt);
     rec_cnt = play_cnt = 0;
 
Index: /pjproject/trunk/pjmedia/src/pjmedia-codec/speex_codec.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia-codec/speex_codec.c	(revision 5034)
+++ /pjproject/trunk/pjmedia/src/pjmedia-codec/speex_codec.c	(revision 5035)
@@ -805,5 +805,5 @@
 	} else {
 	    /* NB frame */
-	    unsigned int advance = submode;
+	    int advance = submode;
 	    speex_mode_query(&speex_nb_mode, SPEEX_SUBMODE_BITS_PER_FRAME, &advance);
 	    if (advance < 0) {
Index: /pjproject/trunk/pjmedia/src/pjmedia/sdp_neg.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/sdp_neg.c	(revision 5034)
+++ /pjproject/trunk/pjmedia/src/pjmedia/sdp_neg.c	(revision 5035)
@@ -85,5 +85,5 @@
 PJ_DEF(const char*) pjmedia_sdp_neg_state_str(pjmedia_sdp_neg_state state)
 {
-    if (state >=0 && state < (pjmedia_sdp_neg_state)PJ_ARRAY_SIZE(state_str))
+    if ((int)state >=0 && state < (pjmedia_sdp_neg_state)PJ_ARRAY_SIZE(state_str))
 	return state_str[state];
 
Index: /pjproject/trunk/pjnath/src/pjnath/ice_strans.c
===================================================================
--- /pjproject/trunk/pjnath/src/pjnath/ice_strans.c	(revision 5034)
+++ /pjproject/trunk/pjnath/src/pjnath/ice_strans.c	(revision 5035)
@@ -852,6 +852,5 @@
      * checked first.
      */
-    if (ice_st->comp[0]->default_cand >= 0 &&
-	ice_st->comp[0]->cand_list[ice_st->comp[0]->default_cand].type
+    if (ice_st->comp[0]->cand_list[ice_st->comp[0]->default_cand].type
 	    == PJ_ICE_CAND_TYPE_SRFLX)
     {
@@ -1041,5 +1040,5 @@
     } else {
 	pj_ice_strans_comp *comp = ice_st->comp[comp_id - 1];
-	pj_assert(comp->default_cand>=0 && comp->default_cand<comp->cand_cnt);
+	pj_assert(comp->default_cand<comp->cand_cnt);
 	pj_memcpy(cand, &comp->cand_list[comp->default_cand],
 		  sizeof(pj_ice_sess_cand));
Index: /pjproject/trunk/pjsip-apps/src/pjsystest/main_console.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsystest/main_console.c	(revision 5034)
+++ /pjproject/trunk/pjsip-apps/src/pjsystest/main_console.c	(revision 5035)
@@ -100,5 +100,5 @@
 	while (*p && *p!='\r' && *p!='\n') {
 	    unsigned d = (*p - '0');
-	    if (d < 0 || d >= choice->submenu_cnt) {
+	    if (d >= choice->submenu_cnt) {
 		puts("Invalid selection");
 		choice = NULL;
Index: /pjproject/trunk/pjsip-apps/src/samples/pcaputil.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/samples/pcaputil.c	(revision 5034)
+++ /pjproject/trunk/pjsip-apps/src/samples/pcaputil.c	(revision 5035)
@@ -308,5 +308,5 @@
     /* Get codec info and param for the specified payload type */
     app.pt = pkt0.rtp->pt;
-    if (app.pt >=0 && app.pt < 96) {
+    if (app.pt < 96) {
 	T( pjmedia_codec_mgr_get_codec_info(cmgr, pkt0.rtp->pt, &ci) );
     } else {
Index: /pjproject/trunk/pjsip-apps/src/samples/pjsip-perf.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/samples/pjsip-perf.c	(revision 5034)
+++ /pjproject/trunk/pjsip-apps/src/samples/pjsip-perf.c	(revision 5035)
@@ -1216,8 +1216,4 @@
 	case 'c':
 	    app.client.job_count = my_atoi(pj_optarg);
-	    if (app.client.job_count < 0) {
-		PJ_LOG(3,(THIS_FILE, "Invalid --local-port %s", pj_optarg));
-		return -1;
-	    }
 	    if (app.client.job_count > pjsip_cfg()->tsx.max_count)
 		PJ_LOG(3,(THIS_FILE, 
@@ -1260,5 +1256,5 @@
 	case 't':
 	    app.client.timeout = my_atoi(pj_optarg);
-	    if (app.client.timeout < 0 || app.client.timeout > 600) {
+	    if (app.client.timeout > 600) {
 		PJ_LOG(3,(THIS_FILE, "Invalid --timeout %s", pj_optarg));
 		return -1;
Index: /pjproject/trunk/pjsip-apps/src/samples/siprtp.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/samples/siprtp.c	(revision 5034)
+++ /pjproject/trunk/pjsip-apps/src/samples/siprtp.c	(revision 5035)
@@ -915,6 +915,7 @@
 	case 'c':
 	    app.max_calls = atoi(pj_optarg);
-	    if (app.max_calls < 0 || app.max_calls > MAX_CALLS) {
-		PJ_LOG(3,(THIS_FILE, "Invalid max calls value %s", pj_optarg));
+	    if (app.max_calls > MAX_CALLS) {
+		PJ_LOG(3,(THIS_FILE,"Invalid max calls value %s "
+				    "(must be <= %d)", pj_optarg, MAX_CALLS));
 		return 1;
 	    }
Index: /pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 5034)
+++ /pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 5035)
@@ -3637,6 +3637,7 @@
     if (pjsip_cfg()->endpt.disable_secure_dlg_check == PJ_FALSE &&
 	dlg->secure && e->body.tsx_state.type==PJSIP_EVENT_RX_MSG &&
-	(tsx->role==PJSIP_ROLE_UAC && tsx->status_code/100 == 2 ||
-	 tsx->role==PJSIP_ROLE_UAS && tsx->state == PJSIP_TSX_STATE_TRYING) &&
+	((tsx->role==PJSIP_ROLE_UAC && tsx->status_code/100 == 2) ||
+	 (tsx->role==PJSIP_ROLE_UAS && tsx->state == PJSIP_TSX_STATE_TRYING))
+	&&
 	(tsx->method.id==PJSIP_INVITE_METHOD || 
 	 pjsip_method_cmp(&tsx->method, &pjsip_update_method)==0))
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c	(revision 5034)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c	(revision 5035)
@@ -154,5 +154,5 @@
 	 */
 	if (bytes_read > MIN_SIZE) {
-	    pj_size_t size_eaten;
+	    pj_ssize_t size_eaten;
 	    const pj_sockaddr *src_addr = &rdata->pkt_info.src_addr;
 
Index: /pjproject/trunk/pjsip/src/pjsua2/media.cpp
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua2/media.cpp	(revision 5034)
+++ /pjproject/trunk/pjsip/src/pjsua2/media.cpp	(revision 5035)
@@ -1011,4 +1011,8 @@
 : winId(win_id)
 {
+#if !PJSUA_HAS_VIDEO
+    /* Suppress warning of unused field when video is disabled */
+    PJ_UNUSED_ARG(winId);
+#endif
 }
 