Index: pjproject/trunk/pjmedia/src/pjmedia-codec/opencore_amr.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/opencore_amr.c	(revision 5044)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/opencore_amr.c	(revision 5045)
@@ -569,5 +569,5 @@
     idx = (attr->info.clock_rate <= 8000? IDX_AMR_NB: IDX_AMR_WB);
     enc_mode = pjmedia_codec_amr_get_mode(attr->info.avg_bps);
-    pj_assert(enc_mode >= 0 && enc_mode < amr_bitrates_size[idx]);
+    pj_assert(enc_mode >= 0 && (unsigned)enc_mode < amr_bitrates_size[idx]);
 
     /* Check octet-align */
@@ -603,5 +603,5 @@
 	    l = pj_strlen(&attr->setting.enc_fmtp.param[i].val);
 	    while (l--) {
-		if (*p>='0' && *p<=('0'+amr_bitrates_size[idx]-1)) {
+		if (*p>='0' && (unsigned)*p<=('0'+amr_bitrates_size[idx]-1)) {
 		    pj_int8_t tmp = *p - '0' - enc_mode;
 
@@ -898,6 +898,6 @@
 					   &input->timestamp);
 	if (PJMEDIA_CODEC_MAX_SILENCE_PERIOD == -1 ||
-	    dtx_duration < PJMEDIA_CODEC_MAX_SILENCE_PERIOD*
-                           amr_data->clock_rate/1000)
+	    dtx_duration < (int)(PJMEDIA_CODEC_MAX_SILENCE_PERIOD*
+                                 amr_data->clock_rate/1000))
 	{
 	    output->size = 0;
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/openh264.cpp
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/openh264.cpp	(revision 5044)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/openh264.cpp	(revision 5045)
@@ -195,9 +195,12 @@
 					&h264_name,
 					&pjmedia_vid_codec_h264_match_sdp);
-    pj_assert(status == PJ_SUCCESS);
+    if (status != PJ_SUCCESS)
+	goto on_error;
 
     /* Register codec factory to codec manager. */
     status = pjmedia_vid_codec_mgr_register_factory(mgr,
 						    &oh264_factory.base);
+    if (status != PJ_SUCCESS)
+	goto on_error;
 
     PJ_LOG(4,(THIS_FILE, "OpenH264 codec initialized"));
@@ -373,4 +376,6 @@
     PJ_ASSERT_RETURN(codec, PJ_EINVAL);
 
+    PJ_UNUSED_ARG(factory);
+
     oh264_data = (oh264_codec_data*) codec->codec_data;
     if (oh264_data->enc) {
@@ -471,7 +476,8 @@
     eprm.iPicWidth			= param->enc_fmt.det.vid.size.w;
     eprm.iPicHeight			= param->enc_fmt.det.vid.size.h;
-    eprm.fMaxFrameRate			= (param->enc_fmt.det.vid.fps.num * 1.0 /
+    eprm.fMaxFrameRate			= (param->enc_fmt.det.vid.fps.num *
+					   1.0f /
 					   param->enc_fmt.det.vid.fps.denum);
-    eprm.uiFrameToBeCoded		= -1;
+    eprm.uiFrameToBeCoded		= (unsigned int) -1;
     eprm.iTemporalLayerNum		= 1;
     eprm.uiIntraPeriod			= 0; /* I-Frame interval in frames */
Index: pjproject/trunk/pjmedia/src/pjmedia/sdp_neg.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/sdp_neg.c	(revision 5044)
+++ pjproject/trunk/pjmedia/src/pjmedia/sdp_neg.c	(revision 5045)
@@ -1509,5 +1509,5 @@
 
 /* Register customized SDP format negotiation callback function. */
-PJ_DECL(pj_status_t) pjmedia_sdp_neg_register_fmt_match_cb(
+PJ_DEF(pj_status_t) pjmedia_sdp_neg_register_fmt_match_cb(
 					const pj_str_t *fmt_name,
 					pjmedia_sdp_neg_fmt_match_cb cb)
Index: pjproject/trunk/pjnath/src/pjnath/stun_transaction.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_transaction.c	(revision 5044)
+++ pjproject/trunk/pjnath/src/pjnath/stun_transaction.c	(revision 5045)
@@ -146,4 +146,5 @@
      */
     /* pj_stun_client_tsx_stop(tsx); */
+    PJ_UNUSED_ARG(tsx);
     return PJ_SUCCESS;
 }
Index: pjproject/trunk/pjsip/src/pjsua2/media.cpp
===================================================================
--- pjproject/trunk/pjsip/src/pjsua2/media.cpp	(revision 5044)
+++ pjproject/trunk/pjsip/src/pjsua2/media.cpp	(revision 5045)
@@ -1024,9 +1024,9 @@
     
     PJSUA2_CHECK_EXPR( pjsua_vid_win_get_info(winId, &pj_vwi) );
-    vwi.isNative = pj_vwi.is_native;
+    vwi.isNative = (pj_vwi.is_native != PJ_FALSE);
     vwi.winHandle.type = pj_vwi.hwnd.type;
     vwi.winHandle.handle.window = pj_vwi.hwnd.info.window;
     vwi.renderDeviceId = pj_vwi.rdr_dev;
-    vwi.show = pj_vwi.show;
+    vwi.show = (pj_vwi.show != PJ_FALSE);
     vwi.pos.x = pj_vwi.pos.x;
     vwi.pos.y = pj_vwi.pos.y;